

uniform vec4 u_fogColor;
uniform float u_fogMaxDist;
uniform float u_fogMinDist;

uniform sampler2D s_texture0;

varying vec2 v_texCoord0;
varying float v_eyeDistance;

float computeLinearFogFactor()
{
  float factor;
  
  // compute linear fog equation
  factor =  (fogMaxDist - v_eyeDistance) /
            (fogMaxDist - fogMinDist);
  
  factor = clamp(factor, 0.0, 1.0);
  
  return factor;
}

void main()
{
  float fogFactor = computeLinearFogFactor();
  vec4 baseColor = texture2D(s_texture0, v_texCoord0);
  
  gl_FragColor = mix(fogColor, baseColor, fogFactor);
}
