

uniform sampler2D s_texture0;

varying vec4 shadowCoord; 
varying vec4 v_color0;

void main()
{
  vec4 shadeFactor = texture2DProj(s_texture0, shadowCoord);
  
  float depth = shadowCoord.z / shadowCoord.w;
  
  vec4 shadeColor;
  if(depth > shadeFactor.z + 0.005)
  {
    shadeColor = vec4(0.0, 0.0, 0.0, 0.2);
  }
  else
  {
    shadeColor = vec4(0.0);
  }
  
  gl_FragColor = v_color0 * shadeColor;
}