struct light
{
  vec3 position;
  vec4 ambient;
  vec4 diffuse;
  vec4 specular;
  
  // only directional light is supported
};

const float c_zero = 0.0;
const float c_one = 1.0;

uniform light u_lights[1];

attribute vec4 a_position;
attribute vec3 a_normal;

uniform mat4 u_matWVP;
uniform mat3 u_matWVInvNormals;
uniform mat4 u_projMatVP;
uniform mat4 u_matW;

varying vec4 shadowCoord;
varying vec4 v_color0;

void main()
{
  
  float ndotl;
  vec3 n;
  
  // Shadow mapping
  shadowCoord = u_projMatVP * u_matW * a_position;
  
  // Lighting
  n = u_matWVInvNormals * a_normal;
  n = normalize(n);
  
  v_color0 = vec4(0,0,0,1);
  
  v_color0 += u_lights[0].ambient;
  
  ndotl = max(dot(u_lights[0].position.xyz,n), c_zero);
  v_color0 += (ndotl * u_lights[0].diffuse);
  
  gl_Position = u_matWVP * a_position;
  
}