
struct light
{
  vec3 position;
  vec4 ambient;
  vec4 diffuse;
  vec4 specular;
  
  // only directional light is supported
};

const float c_zero = 0.0;
const float c_one = 1.0;

uniform light u_lights[1];

attribute vec4 a_position;
attribute vec3 a_normal;
attribute vec2 a_texCoord0;

varying vec2 v_texCoord0;
varying vec4 v_color0;

uniform mat4 u_matWVP;
uniform mat3 u_matWVNormals;

void main()
{
  float ndotl;
  vec3 n;
  
  n = u_matWVNormals * a_normal;
  
  v_color0 = vec4(0,0,0,1);
  v_color0 += u_lights[0].ambient;
  
  ndotl = max(dot(u_lights[0].position.xyz,n), c_zero);
  v_color0 += (ndotl * u_lights[0].diffuse);
  
  gl_Position = u_matWVP * a_position;
  v_texCoord0 = a_texCoord0;
}
