uniform sampler2D s_texture0; // Depth
uniform sampler2D s_texture1; // High res
uniform sampler2D s_texture2; // Low res blurred

uniform float u_max;
uniform float u_rec;

varying vec2 v_texCoord0;

void main()
{
  vec4 factor = texture2D(s_texture0, v_texCoord0);
  
  float f =  clamp((u_max - factor.x) * u_rec, 0.0, 1.0);
 
  vec4 baseColor = texture2D(s_texture1, v_texCoord0);
  
  vec3 blurredColor = texture2D(s_texture2, v_texCoord0).rgb;
  gl_FragColor.rgb = mix(blurredColor, baseColor.rgb, f*f);
  gl_FragColor.a = 1.0;
}