attribute vec4 a_position;
attribute vec3 a_normal;
attribute vec2 a_texCoord0;

uniform mat4 u_matWVP;
uniform vec3 u_vecEye;
uniform float u_rimWidth;

varying vec2 v_texCoord0;
varying float v_rim;

void main()
{
  v_texCoord0 = a_texCoord0;
  gl_Position = u_matWVP * a_position;
  
  vec3 E = normalize(a_position.xyz - u_vecEye);
  vec3 normal = normalize(a_normal);

  vec3 nf = faceforward(normal, E, normal);
  float NdotEInv = 1.0 - dot(nf,-E);
  v_rim = smoothstep(1.0 - u_rimWidth, 1.0, NdotEInv);
}