attribute vec4 a_position;
attribute vec3 a_normal;
attribute vec2 a_texCoord0;
attribute float a_transformIndex;

uniform mat4 u_matWVP;
uniform mat4 u_matW;
uniform mat4 u_matA[MAX_TRANSFORMS];
uniform vec3 u_vecEye;

varying vec2 v_texCoord0;
varying vec3 v_R;

void main()
{
  v_texCoord0 = a_texCoord0;
  
  mat4 matWM  = u_matW * u_matA[int(a_transformIndex)];
  vec3 v_pos  = vec3(matWM * a_position);
  vec3 v_norm = vec3(matWM * vec4(a_normal,0));
  gl_Position = u_matWVP * u_matA[int(a_transformIndex)] * a_position;

  vec3 N = normalize(v_norm);
  vec3 E = v_pos - u_vecEye;
  v_R = reflect(E,N);
}