varying vec2 v_texCoord0;
varying vec2 v_texCoord1;
varying vec4 shadowCoord;
varying vec3 v_R;

uniform sampler2D s_texture0;
uniform samplerCube s_texture1;
uniform sampler2D s_texture2;
uniform sampler2D s_texture3;
uniform mat4  u_matVW;
uniform mat3  u_matWVNormals;


void main()
{
  vec4 color   = texture2D(s_texture0,    v_texCoord1);
  vec4 envmap  = textureCube(s_texture1, v_R);
  vec4 specmap = texture2D(s_texture2,  v_texCoord0);
  vec4 shadow  = texture2D(s_texture3, vec2(shadowCoord.x/shadowCoord.w,shadowCoord.y/shadowCoord.w));
  
  float depth = shadowCoord.z / shadowCoord.w;
  
  if(depth > shadow.z + 0.002 && depth < 1.0)
  {
    shadow = vec4(0.75, 0.847, 0.914, 1);
  }
  else
  {
    shadow = vec4(1.0);
  }
  
//  shadow      *=2.0;
//  shadow      += texture2D(s_texture3, vec2(shadowCoord.x/shadowCoord.w+0.01,(shadowCoord.y/shadowCoord.w)+0.01));
//  shadow      += texture2D(s_texture3, vec2(shadowCoord.x/shadowCoord.w-0.01,(shadowCoord.y/shadowCoord.w)-0.01));
//  shadow      += texture2D(s_texture3, vec2((shadowCoord.x/shadowCoord.w)-0.01,shadowCoord.y/shadowCoord.w)+0.01);
//  shadow      += texture2D(s_texture3, vec2((shadowCoord.x/shadowCoord.w)+0.01,shadowCoord.y/shadowCoord.w)-0.01);
//  shadow      += texture2D(s_texture3, vec2((shadowCoord.x/shadowCoord.w)+0.02,shadowCoord.y/shadowCoord.w));
//  shadow      += texture2D(s_texture3, vec2((shadowCoord.x/shadowCoord.w),shadowCoord.y/shadowCoord.w)+0.02);
//  shadow      /= 8.0;
  
  envmap *= specmap;

  gl_FragColor = (color * shadow) + envmap;

}