attribute vec4 a_position;
attribute vec3 a_normal;
attribute vec2 a_texCoord0;
attribute vec2 a_texCoord1;

uniform mat4 u_matWVP;
uniform mat4 u_matW;
uniform vec3 u_vecEye;
uniform mat4 u_matWInv;
uniform mat4 u_projMatVP;

varying vec2 v_texCoord0;
varying vec2 v_texCoord1;
varying vec4 shadowCoord;
varying vec3 v_R;

void main()
{
  v_texCoord0 = a_texCoord0;
  v_texCoord1 = a_texCoord1;
  shadowCoord = u_projMatVP * a_position;
  vec3 v_pos =  vec3(u_matW*a_position);
  vec3 v_norm = vec3(u_matW*vec4(a_normal,0));
  gl_Position = u_matWVP * a_position;
  
  vec3 N = normalize(v_norm);
  //  vec3 E = vec3(a_position) - vec3(vec4(u_vecEye,1) * u_matWInv);
  vec3 E = v_pos - u_vecEye;
  vec3 R = reflect(E,N);
  v_R = R;
}